//KreiseMuster_502d.js
// 12.07.16 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Ein Muster aus Kreisen

/*
Credits (betreffend die nderungen in der Version 502d): 
 Kai Rbsamen meldete das Problem mit der Ausrichtung der 'border panels' mit CC 2014.
 Uwe Laubender wnschte ...
  ... die Ergnzung mit "Konturausrichtung: 'auen'"; 
  ... eine Wahl, ob ein Objektformat zugewiesen wird (oder nicht); 
  ... das Einfgen eines doScript-Befehls, dank welchem smtliche Aktionen 
      des Scripts mit _einem_ Befehl+Z rckgngig gemacht werden knnen.
*/

app.doScript(circles, ScriptLanguage.JAVASCRIPT, undefined, UndoModes.ENTIRE_SCRIPT, "KreiseMuster"); 

function circles() {
	// vorbeugenderweise das Anzeigen von Dialogen aktivieren
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
	
	// prfen, ob ein Dokument geffnet ist
	if (app.documents.length == 0) {
		alert ("Es ist kein Dokument offen.", "Achtung");
		exit();
	}
	
	// das aktive Dokument, die aktive Seite
	curDoc = app.activeDocument;
	var curPage = curDoc.layoutWindows[0].activePage;
	
	// die Version speichern
	appVers = (app.version[0])*1;
	
	// die Namen der fixen Farbfelder definieren
	noColor    = "[None]";
	regisColor = "[Registration]";
	paperColor = "[Paper]";
	blackColor = "[Black]";
	
	// die Sprache des Programms speichern
	var curLang = (app.locale)*1;
	
	// die Namen der Farbfelder vorbereiten (in FR and DE)
	if (curLang   == 1279477362) { // = Franzsisch
		noColor      = "[Sans]";
		regisColor   = "[Registration]";
		paperColor   = "[Papier]";
		blackColor   = "[Noir]";
		if (appVers == 4) {
			noColor    = "[Aucun]";
			regisColor = "[Registration]";
		}
	}
	else if (curLang == 1279477613) { // = Deutsch
		noColor      = "[Ohne]";
		regisColor   = "[Passermarken]";
		paperColor   = "[Papier]";
		blackColor   = "[Schwarz]";
		if (appVers == 4) {
			noColor    = "[Keine]";
			regisColor = "[Passkreuze]";
		}
	}
	
	// die aktuellen Masseinheiten speichern, prfen und ndern (falls notwendig) /////////////////////
	hM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
	vM = (curDoc.viewPreferences.verticalMeasurementUnits)*1;
	if (vM != hM) {
		curDoc.viewPreferences.verticalMeasurementUnits = hM;
	}
	
	if (hM == 2054188905) {
		strgUnit = "pt";
	}
	else if (hM == 2054187363) {
		strgUnit = "p";
	}
	else if (hM == 2053729891) {
		strgUnit = "in";
	}
	else if (hM == 2053729892) {
		strgUnit = "in";
	}
	else if (hM == 2053991795) {
		strgUnit = "mm";
	}
	else if (hM == 2053336435) {
		strgUnit = "cm";
	}
	else if (hM == 2053335395) {
		strgUnit = "c";
	}
	else if (hM == 2051106676) {
		strgUnit = "ag";
	}
	else if (hM == 2054187384) {
		strgUnit = "px";
	}
	else if (hM == 1131639917) {
		strgUnit = "ud";
	}
	else {
		strgUnit = "un";
	}
	
	// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
	var defStr = getPrefs();
	// wenn die Vorgabendatei existiert, die Werte ausziehen
	if (defStr != "") {
		repDef = defStr.split("\n");
		prefUnit = repDef[0];
		dTmp  = repDef[1]*1;
		dVal  = convVal(prefUnit, strgUnit, dTmp, 0);
		bNm   = repDef[2];
		if (bNm == "Black") { bNm = blackColor; }
		else if (bNm == "Paper") { bNm = paperColor; }
		else if (bNm == "Registration") { bNm = regisColor; }
		else if (bNm == "None") { bNm = noColor; }
		bgT   = repDef[3]*1;
		var sNm = repDef[4];
		if (sNm == "Black") { sNm = blackColor; }
		else if (sNm == "Paper") { sNm = paperColor; }
		else if (sNm == "Registration") { sNm = regisColor; }
		else if (sNm == "None") { sNm = noColor; }
		stT   = repDef[5]*1;
		strW  = repDef[6]*1;
		strA  = repDef[7]*1;
		aTmp  = repDef[8]*1;
		aVal  = convVal(prefUnit, strgUnit, aTmp, 1);
		nRows = repDef[9]*1;
		nCols = repDef[10]*1;
		xTmp  = repDef[11]*1;
		xDef  = convVal(prefUnit, strgUnit, xTmp, 2);
		yTmp  = repDef[12]*1;
		yDef  = convVal(prefUnit, strgUnit, yTmp, 3);
		stDec = repDef[13];
		if (stDec == "0") {
			rb01 = 1;
			rb02 = 0;
		}
		else if (stDec == "1") {
			rb01 = 0;
			rb02 = 1;
		}
		psDec = repDef[14];
		if (psDec == "0") {
			rb03 = 1;
			rb04 = 0;
		}
		else if (psDec == "1") {
			rb03 = 0;
			rb04 = 1;
		}
		osDec = repDef[15];
		if (osDec == "0") {
			rb05 = 1;
			rb06 = 0;
		}
		else if (osDec == "1") {
			rb05 = 0;
			rb06 = 1;
		}
	}
	else { // wenn keine Vorgabendatei gefunden wurde
		dVal  = get_dVal(strgUnit);
		bNm   = paperColor;
		bgT   = 100;
		sNm   = blackColor;
		stT   = 100;
		strW  =   6;
		strA  =   0;
		aVal  =   0;
		nRows =   5;
		nCols =   5;
		xDef  = get_xDef(strgUnit);
		yDef  = xDef;
		rb01  =   1;
		rb02  =   0;
		rb03  =   1;
		rb04  =   0;
		rb05  =   1;
		rb06  =   0;
	}
	
	// die Funktion aufrufen, welche die Arrays der Farben vorbereitet
	bgrColor = getColorList(bNm);
	bgrCol   = bgrColor[0];
	bInd     = bgrColor[1];
	strColor = getColorList(sNm);
	strCol   = strColor[0];
	sInd     = strColor[1];
	
	// der Array fr die Ausrichtung der Kontur
	strAlg = new Array("mittig", "innen", "auen");
	
	// die Funktion aufrufen, welche den Dialog zeigt und auswertet
	reArr = askUser();
	dVal  = reArr[1];
	bNm   = reArr[2];
	bgT   = reArr[3];
	sNm   = reArr[4];
	stT   = reArr[5];
	strW  = reArr[6];
	strA  = reArr[7];
	aVal  = reArr[8];
	nRows = reArr[9];
	nCols = reArr[10];
	xDef  = reArr[11];
	yDef  = reArr[12];
	stDec = reArr[13];
	psDec = reArr[14];
	osDec = reArr[15];
	
	// die Konturstrke in die aktuelle Masseinheit umrechnen
	var strM = get_defVal(strgUnit, strW);
	
	// wenn Konturstrke Null, die Konturfarbe auf "[Ohne]" setzen
	if (strM == 0) {
		sColor = noColor;
	}
	
	// wenn Konturfarbe "[Ohne]", die Konturstrke auf Null setzen
	if (sColor == "None") {
		(strM = 0);
	}
	
	// die Startpositions-Werte anderen Variablen zuweisen
	yPos = yDef;
	xPos = xDef;
	
	// wenn die Konturstrke nicht bercksichtigt werden soll
	if (stDec == 0) {
		if (strA == 0) { // wenn "mittig"
			strM = 0;
		}
		else if (strA == 1) { // wenn "innen" oder "auen"
			strM = 0-strM;
		}
	}
	else {
		if (strA == 1) { // wenn "innen"
			strM = 0;
		}
		else if (strA == 2) { // wenn "auen"
			strM = strM*2;
		}
	}
	
	// die Vorschubwerte berechnen
	if (strA == 0) { // wenn "mittig"
		if (psDec == 0) { // alle links aliniert
			var yVal = (dVal+aVal+strM);
			var xVal = dVal;
		}
		else { // jede zweite Reihe mit Einzug 
			var yVal = (((dVal+aVal+strM)/100)*86.625);
			var xVal = (dVal+aVal+strM)/2;
		}
	}
	else { // wenn "innen" oder "auen"
		if (psDec == 0) { // alle links aliniert
			var yVal = (dVal+aVal+strM);
			var xVal = dVal;
		}
		else { // jede zweite Reihe mit Einzug
			var yVal = (((dVal+aVal+strM)/100)*86.625);
			var xVal = (dVal+aVal+strM)/2;
		}
	}
	
	// den Linealursprung auf "Seite" setzen
	rO = curDoc.viewPreferences.rulerOrigin;
	if (rO != 1380143215) {
		curDoc.viewPreferences.rulerOrigin = RulerOrigin.PAGE_ORIGIN;
	}
	// den Nullpunkt auf Null/Null setzen
	zP = curDoc.zeroPoint; 
	if (zP != [0,0]) {
		curDoc.zeroPoint = [0,0];
	}
	
	// die aktive Ebene entsperren (falls notwendig)
	var layerLocked = false;
	curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		layerLocked = true;
		curLayer.locked = false;
	}
	
	// eventuelle 100%-Prozent-Werte in -1 umwandeln
	if (bgrT == 100) {
		bgrT = -1;
	}
	if (strT == 100) {
		strT = -1;
	}
	
	// prfen, ob ein bestimmtes Objektformat vorhanden ist
	if (osDec == 0) {
		if (curDoc.objectStyles.itemByName("k_001").isValid) {
			// die Objektformate auflisten und zhlen
			var allObjStyles = curDoc.objectStyles.everyItem().name;
			var nStyles = allObjStyles.length;
			// einen Array vorbereiten
			var objStyleArr = new Array();
			// einen Schleife durch die Formate und jene mit "k_" in den Array aufnehmen 
			// aber nur, wenn die drei letzten Zeichen eine Zahl sind
			for (var o=0; o<nStyles; o++) {
				var curStyle = allObjStyles[o];
				if (curStyle.slice(0,2) == "k_") {
					if (!isNaN(curStyle.slice(-3))) {
						objStyleArr.push(curStyle);
					}
				}
			}
			// den Array sortieren
			objStyleArr.sort();
			// das letzte Element des Arrays
			var lastStyle = objStyleArr.pop();
			// die Nummer ausziehen
			var lastNum = lastStyle.slice(-3)*1;
			// hochzhlen und Nullen davorsetzen
			var newNum = ("00" + (lastNum+1)).slice(-3);
			// den neuen Namen zusammensetzen
			var newName = "k_" + newNum;
		}
		else {
			var newName = "k_001";
		}
		
		// ein Objektformat erzeugen
		objStyle = curDoc.objectStyles.add();
		objStyle.name = newName;
		objStyle.properties = {fillColor:bColor, fillTint:bgrT};
		objStyle.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT};
		if (strA == 0) {
			objStyle.strokeAlignment = StrokeAlignment.centerAlignment;
		}
		else if (strA == 1) {
			objStyle.strokeAlignment = StrokeAlignment.insideAlignment;
		}
		else {
			objStyle.strokeAlignment = StrokeAlignment.outsideAlignment;
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	// die Schleife, in welcher die Kreise erzeugt werden /////////////////////////////////////////////
	for (var r=0; r<nRows; r++) {
		var curFrame = curPage.ovals.add();
		if (osDec == 0) {
			curFrame.applyObjectStyle(objStyle);
		}
		else {
			curFrame.properties = {fillColor:bColor, fillTint:bgrT};
			curFrame.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT};
			if (strA == 0) {
				curFrame.strokeAlignment = StrokeAlignment.centerAlignment;
			}
			else if (strA == 1) {
				curFrame.strokeAlignment = StrokeAlignment.insideAlignment;
			}
			else {
				curFrame.strokeAlignment = StrokeAlignment.outsideAlignment;
			}
		}
		curFrame.properties = {geometricBounds:[yDef, xDef, yDef+dVal, xDef+dVal]};
		var newFrame = curFrame;
		
		for (var n=0; n<nCols-1; n++) {
			xPos = dVal + aVal + strM;
			var newFrame = newFrame.duplicate(undefined, [xPos,0]);
		}
	
		yDef = yDef+yVal;
		if (psDec == 1) {
			if (r%2 == 1) {
				xDef = xDef-xVal;
			}
			else {
				xDef = xDef+xVal;
			}
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	// die Einstellungs-nderungen zurcksetzen (falls notwendig) /////////////////////////////////////
	// die Masseinheiten zurcksetzen
	if (vM != hM) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	// den Linealursprung wiederherstellen
	if (rO != 1380143215) {
		curDoc.viewPreferences.rulerOrigin = rO;
	}
	// den Nullpunkt zurcksetzen
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	}
	// die aktive Ebene wieder sperren (falls sie gesperrt war)
	if (layerLocked) {
		curLayer.locked = true;
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	// das Ende der Aktion verknden //////////////////////////////////////////////////////////////////
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// eine kleine Pause
	$.sleep(999);
	// das Fenster schliessen
	dlog.close();
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// die weiteren Funktionen ////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// die Informationen vorbereiten //////////////////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Kreise502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Kreise502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// bei der ersten Ausfhrung die Vorgabewerte bestimmen ///////////////////////////////////////////
function get_dVal(strgUnit) { // der Durchmesser der Kreise
	if (strgUnit == "mm") {
		return 20/0.352778;
	}
	else if (strgUnit == "cm") {
		return 20/0.352778;
	}
	else if (strgUnit == "pt") {
		return 60;
	}
	else if (strgUnit == "in") {
		return 72;
	}
	else if (strgUnit == "p") {
		return 60;
	}
	else if (strgUnit == "c") {
		return (5/0.078199);
	}
	else if (strgUnit == "ag") {
		return (12/0.194444444444);
	}
	else if (strgUnit == "px") {
		return 60;
	}
	else {
		return 20;
	}
}

function get_xDef(strgUnit) { // der Abstand zum linken Seitenrand
	if (strgUnit == "mm") {
		return 30/0.352778;
	}
	else if (strgUnit == "cm") {
		return 30/0.352778;
	}
	else if (strgUnit == "pt") {
		return 90;
	}
	else if (strgUnit == "in") {
		return 108;
	}
	else if (strgUnit == "p") {
		return 84;
	}
	else if (strgUnit == "c") {
		return (7/0.078199);
	}
	else if (strgUnit == "ag") {
		return (18/0.194444444444);
	}
	else if (strgUnit == "px") {
		return 90;
	}
	else {
		return 20;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// die gespeicherten Vorgabewerte umrechnen ///////////////////////////////////////////////////////
function convVal(prefUnit, strgUnit, curVal, curFlag) {
	if (prefUnit == strgUnit) {
		if (strgUnit == "mm") {
			return (curVal/0.352778);
		}
		else if (strgUnit == "cm") {
			return (curVal/0.0352778);
		}
		else if (strgUnit == "pt" || strgUnit == "px") {
			return curVal;
		}
		else if (strgUnit == "in") {
			return (curVal*72);
		}
		else if (strgUnit == "p") {
			return (curVal*12);
		}
		else if (strgUnit == "c") {
			return (curVal/0.078199);
		}
		else if (strgUnit == "ag") {
			return (curVal/0.194444444444);
		}
		else {
			return curVal;
		}
	}
	else {
		if (prefUnit == "mm") {
			if (strgUnit == "cm") {
				return (curVal/0.352778);
			}
			else {
				if (curFlag == 0) {
					var defaultVal = get_dVal(strgUnit);
					return defaultVal;
				}
				else if (curFlag == 1) {
					return 0;
				}
				else {
					var defaultVal = get_xDef(strgUnit);
					return defaultVal;
				}
			}
		}
		else if (prefUnit == "cm") {
			if (strgUnit == "mm") {
				return (curVal/0.0352778);
			}
			else {
				if (curFlag == 0) {
					var defaultVal = get_dVal(strgUnit);
					return defaultVal;
				}
				else if (curFlag == 1) {
					return 0;
				}
				else {
					var defaultVal = get_xDef(strgUnit);
					return defaultVal;
				}
			}
		}
		else if (prefUnit == "pt") {
			if (strgUnit == "in") {
				return (curVal*1.2);
			}
			else if (strgUnit == "px") {
				return curVal;
			}
			else {
				if (curFlag == 0) {
					var defaultVal = get_dVal(strgUnit);
					return defaultVal;
				}
				else if (curFlag == 1) {
					return 0;
				}
				else {
					var defaultVal = get_xDef(strgUnit);
					return defaultVal;
				}
			}
		}
		else if (prefUnit == "in") {
			if (strgUnit == "pt") {
				return (curVal*60);
			}
			else if (strgUnit == "px") {
				return (curVal*60);
			}
			else {
				if (curFlag == 0) {
					var defaultVal = get_dVal(strgUnit);
					return defaultVal;
				}
				else if (curFlag == 1) {
					return 0;
				}
				else {
					var defaultVal = get_xDef(strgUnit);
					return defaultVal;
				}
			}
		}
		else if (prefUnit == "px") {
			if (strgUnit == "in") {
				return (curVal*1.2);
			}
			else if (strgUnit == "pt") {
				return curVal;
			}
			else {
				if (curFlag == 0) {
					var defaultVal = get_dVal(strgUnit);
					return defaultVal;
				}
				else if (curFlag == 1) {
					return 0;
				}
				else {
					var defaultVal = get_xDef(strgUnit);
					return defaultVal;
				}
			}
		}
		else if (prefUnit == "p") {
			if (curFlag == 0) {
				var defaultVal = get_dVal(strgUnit);
				return defaultVal;
			}
			else if (curFlag == 1) {
				return 0;
			}
			else {
				var defaultVal = get_xDef(strgUnit);
				return defaultVal;
			}
		}
		else if (prefUnit == "c") {
			if (curFlag == 0) {
				var defaultVal = get_dVal(strgUnit);
				return defaultVal;
			}
			else if (curFlag == 1) {
				return 0;
			}
			else {
				var defaultVal = get_xDef(strgUnit);
				return defaultVal;
			}
		}
		else if (prefUnit == "ag") {
			if (curFlag == 0) {
				var defaultVal = get_dVal(strgUnit);
				return defaultVal;
			}
			else if (curFlag == 1) {
				return 0;
			}
			else {
				var defaultVal = get_xDef(strgUnit);
				return defaultVal;
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// die gewnschten Werte umrechnen ////////////////////////////////////////////////////////////////
function get_defVal(strgUnit, curVal) {
	if (strgUnit == "mm") {
		return ((curVal*0.352778).toFixed(3))*1;
	}
	else if (strgUnit == "cm") {
		return (((curVal*0.352778).toFixed(3))*1)/10;
	}
	else if (strgUnit == "pt" || strgUnit == "px") {
		return curVal;
	}
	else if (strgUnit == "in") {
		return curVal/72;
	}
	else if (strgUnit == "p") {
		return curVal/12;
	}
	else if (strgUnit == "c") {
		return curVal*0.078199;
	}
	else if (strgUnit == "ag") {
		return (curVal*0.194444444444);
	}
	else {
		return curVal;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// die Listen der Fll- und Kontur-Farben vorbereiten /////////////////////////////////////////////
function getColorList(bName) {
	// eine Variable als Referenz zu den Farbfeldern des aktiven Dokuments definieren
	var allSwatches = curDoc.swatches;
	
	// prfen, ob die Vorgabefarbe existiert
	if (bName != blackColor && bName != paperColor && bName != noColor && bName != regisColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = blackColor;
		}
	}
	
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var colorList = new Array();
	var bIndex = 0;
	for (var n=0; n<allSwatches.length; n++) {
		cName = allSwatches.item(n).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (bName == cName) {
			bIndex = n;
		}
		if (cName != "Registration") {
			colorList.push(cName);
		}
	}
	return [colorList, bIndex];
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// den Dialog vorbereiten, anzeigen und auswerten /////////////////////////////////////////////////
function askUser() {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth1 = 130;
	var labelWidth2 = 128;
	var fieldWidth1 =  32;
	var fieldWidth2 =  80;
	if (appVers == 1) {
		var menueWidth1 = 225;
		var bttnsWidth1 = 227;
	}
	else {
		var menueWidth1 = 234;
		var bttnsWidth1 = 236;
	}
	var aDialog = app.dialogs.add({name:"KreiseMuster"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Durchmesser", minWidth:labelWidth1});
					var sizeField = measurementEditboxes.add({editValue:dVal, editUnits:hM, minWidth:fieldWidth2});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Fllfarbe", minWidth:labelWidth1});
					var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:menueWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Farbton", minWidth:labelWidth1});
					var bgrTint = realEditboxes.add({editValue:bgT, minimumValue:0, maximumValue:100, minWidth:fieldWidth1});
					staticTexts.add({staticLabel:"%", minWidth:8});
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Konturfarbe", minWidth:labelWidth1});
					var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:menueWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Farbton", minWidth:labelWidth1});
					var strTint = realEditboxes.add({editValue:stT, minimumValue:0, maximumValue:100, minWidth:fieldWidth1});
					staticTexts.add({staticLabel:"%", minWidth:8});
					staticTexts.add({staticLabel:"Konturstrke", minWidth:105});
					var strWeight = realEditboxes.add({editValue:strW, minWidth:fieldWidth1});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Konturausrichtung", minWidth:labelWidth1});
					var strAlig = dropdowns.add({stringList:strAlg, selectedIndex:strA, minWidth:menueWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Abstand", minWidth:labelWidth1});
					var distField = measurementEditboxes.add({editValue:aVal, editUnits:hM, minWidth:fieldWidth2});
					staticTexts.add({staticLabel:"(zwischen den Kreisen)"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Reihen", minWidth:labelWidth1});
					var rowsField = integerEditboxes.add({editValue:nRows, minWidth:fieldWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Spalten", minWidth:labelWidth1});
					var colsField = integerEditboxes.add({editValue:nCols, minWidth:fieldWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Start-Position links", minWidth:labelWidth1});
					var startX_Field = measurementEditboxes.add({editValue:xDef, editUnits:hM, minWidth:fieldWidth2});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Start-Position oben", minWidth:labelWidth1});
					var startY_Field = measurementEditboxes.add({editValue:yDef, editUnits:hM, minWidth:fieldWidth2});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ausgangswert fr den Abstand zwischen den Kreisen ..."});
					staticTexts.add({staticLabel:"", minWidth:2});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:labelWidth2});
					with(strButtns = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:" die Konturen bereinanderlegen", checkedState:rb01, minWidth:bttnsWidth1});
						radiobuttonControls.add({staticLabel:" die Konturen berhren sich", checkedState:rb02});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Die horizontale Position der Reihen ..."});
					staticTexts.add({staticLabel:" ", minWidth:2});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:labelWidth2});
					with(posButtns = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:" alle links aliniert", checkedState:rb03, minWidth:bttnsWidth1});
						radiobuttonControls.add({staticLabel:" jede zweite mit 50%-Einzug", checkedState:rb04});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Den Kreisrahmen ein Objektformat zuweisen?"});
					staticTexts.add({staticLabel:" ", minWidth:2});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:labelWidth2});
					with(objButtns = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:" ja, bitte", checkedState:rb05, minWidth:bttnsWidth1});
						radiobuttonControls.add({staticLabel:" nein, danke", checkedState:rb06});
					}
				}
			}
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		curVal = (sizeField.editValue);
		dVal   = get_defVal(strgUnit, curVal);
		bgrIndex = bgrColor.selectedIndex;
		bColor   = curDoc.swatches[bgrIndex].name;
		if (bColor == blackColor) { bColor = "Black"; }
		else if (bColor == paperColor) { bColor = "Paper"; }
		else if (bColor == regisColor) { bColor = "Registration"; }
		else if (bColor == noColor) { bColor = "None"; }
		bgrT   = bgrTint.editValue;
		strIndex = strColor.selectedIndex;
		sColor = curDoc.swatches[strIndex].name;
		if (sColor == blackColor) { sColor = "Black"; }
		else if (sColor == paperColor) { sColor = "Paper"; }
		else if (sColor == regisColor) { sColor = "Registration"; }
		else if (sColor == noColor) { sColor = "None"; }
		strT   = strTint.editValue;
		strW   = strWeight.editValue;
		strA   = strAlig.selectedIndex;
		curVal = (distField.editValue);
		aVal   = get_defVal(strgUnit, curVal);
		nRows  = rowsField.editValue;
		nCols  = colsField.editValue;
		curVal = (startX_Field.editValue);
		xDef   = get_defVal(strgUnit, curVal);
		curVal = (startY_Field.editValue);
		yDef   = get_defVal(strgUnit, curVal);
		stDec  = strButtns.selectedButton;
		psDec  = posButtns.selectedButton;
		osDec  = objButtns.selectedButton;
		
		aDialog.destroy();
	
		// die Liste der Einstellungen ...
		var prefsList = new Array(strgUnit,dVal,bColor,bgrT,sColor,strT,strW,strA,aVal,nRows,nCols,xDef,yDef,stDec,psDec,osDec);
		// ... in eine Textkette verwandeln ...
		var curDef = prefsList.join("\n");
		// ... zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(curDef);
		// das Ergebnis zum Aufruf zurckschicken
		return prefsList;
	}
	else {
		aDialog.destroy();
		exit();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Kreise502.txt");
	}
	else {
		var f = File("~/Library/Preferences/Kreise502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}